/* --------------------  TXTOOLS.H  ------------------

     Einige wenige Funktionen fuer die Bildschirm-
     steuerung im Textmodus

     29.03.2014  R. Seelig
   --------------------------------------------------- */

#ifndef in_txtools2
  #define in_txtools2


  #include <termios.h>         // fuer getch()
  #include <stdlib.h>
  #include <stdio.h>
  #include <string.h>
  #include <unistd.h>
  #include <fcntl.h>
  #include <stdint.h>

  #define esc             27

  #define black           0
  #define blue            1
  #define green           2
  #define cyan            3
  #define red             4
  #define magenta         5
  #define brown           6
  #define grey            7
  #define darkgrey        8
  #define lightblue       9
  #define lightgreen      10
  #define lightcyan       11
  #define lightred        12
  #define lightmagenta    13
  #define yellow          14
  #define white           15


  #define keyleft         0x00005b44
  #define keyright        0x00005b43
  #define keyup           0x00005b41
  #define keydown         0x00005b42
  #define pageup          0x005b357e
  #define pagedown        0x005b367e
  #define keypos1         0x00005b48
  #define keyend          0x00005b46

  #define keyf1           0x00004f50
  #define keyf2           0x00004f51
  #define keyf3           0x00004f52
  #define keyf4           0x00004f53
  #define keyf5           0x5b31357e
  #define keyf6           0x5b31377e
  #define keyf7           0x5b31387e
  #define keyf8           0x5b31397e
  #define keyf9           0x5b32307e
  #define keyf10          0x5b32317e


  // ----------------- Globale Variable ---------------


  struct txfntset
  {
    int             flen;                 // Bytes per Zeichen eines Fonts
    int             fresx;                // Pixelgroesse eines Fonts in x-Achse
    int             fresy;                // dto. y-Achse
    unsigned char*  fptr;                 // Zeiger auf den Schriftstil
    int             fcolor;
    char            modus;
  };

  extern char axofs;
  extern char ayofs;
  extern unsigned char colattr;
  extern uint8_t txwherex;
  extern uint8_t txwherey;

  #define fnt8x14bytes     14
  extern char fnt8x14[256][14];
  #define fnt12x16bytes     32
  extern char fnt12x16 [256][32];

  extern char txpal[];
  extern char bkpal[];



  // ---------------  Prototypen Text -----------------

  void settextcolor(unsigned char col);
  void setbkcolor(unsigned char col);
  void settextattr(unsigned char attr);
  void clrscr(void);
  void gotoxy(unsigned char x, unsigned char y);
  void txbar(char x1, char y1, char x2, char y2, char f);
  void settxfont(char nr);
  void tx_putchar(int ch, char c1, char c2);
  void tx_putstring(char x, char y, uint8_t f, char c1, char c2, unsigned char *c);
  int getch(void);
  unsigned int readkey(void);
  int keypressed(void);

#endif
